/****************************************************************************
**
** Copyright (C) 2023 The Qt Company Ltd.
** Contact: https://www.qt.io/licensing/
**
** This file is part of the Qt Design Viewer of the Qt Toolkit.
**
** Commercial License Usage
** Licensees holding valid commercial Qt licenses may use this file in
** accordance with the commercial license agreement provided with the
** Software or, alternatively, in accordance with the terms contained in
** a written agreement between you and The Qt Company. For licensing terms
** and conditions see https://www.qt.io/terms-conditions. For further
** information use the contact form at https://www.qt.io/contact-us.
**
** GNU General Public License Usage
** Alternatively, this file may be used under the terms of the GNU
** General Public License version 3 as published by the Free Software
** Foundation with exceptions as appearing in the file LICENSE.GPL3-EXCEPT
** included in the packaging of this file. Please review the following
** information to ensure the GNU General Public License requirements will
** be met: https://www.gnu.org/licenses/gpl-3.0.html.
**
****************************************************************************/

#ifndef SERVICECONNECTOR_H
#define SERVICECONNECTOR_H

#include <QNetworkAccessManager>
#include <QJsonArray>

class ServiceConnector : public QObject
{
    Q_OBJECT
public:
    QByteArray fetchProject(const QString &url);
    QByteArray fetchUserProject(const QString &userHash, const QString &projectName);
    QJsonArray fetchUserProjectList(const QString &userHash);
    QJsonArray fetchUserDemoList();

private:
    QNetworkAccessManager m_manager;
    QByteArray fetchResource(const QString &url);

signals:
    void downloadProgress(float percentage);
};

#endif // SERVICECONNECTOR_H
